Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerForm.cs	(revision 3006)
@@ -13,5 +13,4 @@
   public partial class InstallationManagerForm : Form {
     private class UpdateOrInstallPluginsBackgroundWorkerArgument {
-      public string ConnectionString { get; set; }
       public IEnumerable<IPluginDescription> PluginsToUpdate { get; set; }
       public IEnumerable<IPluginDescription> PluginsToInstall { get; set; }
@@ -56,9 +55,4 @@
       refreshLocalPluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(refreshLocalPluginsBackgroundWorker_RunWorkerCompleted);
       #endregion
-
-      // get default connection string
-      using (var client = new DeploymentService.UpdateClient()) {
-        serverUrlTextBox.Text = client.Endpoint.Address.ToString();
-      }
 
       installationManager = new InstallationManager(pluginDir);
@@ -130,6 +124,6 @@
     void updateOrInstallPluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
       UpdateOrInstallPluginsBackgroundWorkerArgument info = (UpdateOrInstallPluginsBackgroundWorkerArgument)e.Argument;
-      installationManager.Install(info.ConnectionString, info.PluginsToInstall);
-      installationManager.Update(info.ConnectionString, info.PluginsToUpdate);
+      installationManager.Install(info.PluginsToInstall);
+      installationManager.Update(info.PluginsToUpdate);
     }
     #endregion
@@ -147,9 +141,7 @@
 
     void refreshServerPluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
-      string connectionString = (string)e.Argument;
-
       RefreshBackgroundWorkerResult result = new RefreshBackgroundWorkerResult();
-      result.RemotePlugins = installationManager.GetRemotePluginList(connectionString);
-      result.RemoteProducts = installationManager.GetRemoteProductList(connectionString);
+      result.RemotePlugins = installationManager.GetRemotePluginList();
+      result.RemoteProducts = installationManager.GetRemoteProductList();
       e.Cancel = false;
       e.Result = result;
@@ -180,16 +172,24 @@
     #region installation manager event handlers
     void installationManager_PreUpdatePlugin(object sender, PluginInfrastructureCancelEventArgs e) {
-      if (ConfirmUpdateAction(e.Entities) == true) e.Cancel = false;
-      else e.Cancel = true;
+      if (e.Plugins.Count() > 0) {
+        e.Cancel = ConfirmUpdateAction(e.Plugins) == false;
+      }
     }
 
     void installationManager_PreRemovePlugin(object sender, PluginInfrastructureCancelEventArgs e) {
-      if (ConfirmRemoveAction(e.Entities) == true) e.Cancel = false;
-      else e.Cancel = true;
+      if (e.Plugins.Count() > 0) {
+        e.Cancel = ConfirmRemoveAction(e.Plugins) == false;
+      }
     }
 
     void installationManager_PreInstallPlugin(object sender, PluginInfrastructureCancelEventArgs e) {
-      if (e.Entities.Count() > 0)
-        SetStatusStrip("Installing " + e.Entities.Aggregate((a, b) => a + Environment.NewLine + b));
+      if (e.Plugins.Count() > 0)
+        if (ConfirmInstallAction(e.Plugins) == true) {
+          SetStatusStrip("Installing " + e.Plugins.Aggregate("", (a, b) => a.ToString() + "; " + b.ToString()));
+          e.Cancel = false;
+        } else {
+          e.Cancel = true;
+          SetStatusStrip("Install canceled");
+        }
     }
 
@@ -239,5 +239,4 @@
       var pluginsToInstall = remotePluginInstaller.CheckedPlugins.Except(pluginsToUpdate);
 
-      updateOrInstallInfo.ConnectionString = serverUrlTextBox.Text;
       updateOrInstallInfo.PluginsToInstall = pluginsToInstall;
       updateOrInstallInfo.PluginsToUpdate = pluginsToUpdate;
@@ -255,21 +254,35 @@
 
     #region confirmation dialogs
-    private bool ConfirmRemoveAction(IEnumerable<string> fileNames) {
+    private bool ConfirmRemoveAction(IEnumerable<IPluginDescription> plugins) {
       StringBuilder strBuilder = new StringBuilder();
       strBuilder.AppendLine("Delete files:");
-      foreach (var fileName in fileNames) {
-        strBuilder.AppendLine(fileName);
+      foreach (var plugin in plugins) {
+        foreach (var file in plugin.Files) {
+          strBuilder.AppendLine(file.ToString());
+        }
       }
       return MessageBox.Show(strBuilder.ToString(), "Confirm Delete", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK;
     }
 
-    private bool ConfirmUpdateAction(IEnumerable<string> plugins) {
+    private bool ConfirmUpdateAction(IEnumerable<IPluginDescription> plugins) {
       StringBuilder strBuilder = new StringBuilder();
       strBuilder.AppendLine("Update plugins:");
       foreach (var plugin in plugins) {
-        strBuilder.AppendLine(plugin);
+        strBuilder.AppendLine(plugin.ToString());
       }
       return MessageBox.Show(strBuilder.ToString(), "Confirm Update", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK;
     }
+
+    private bool ConfirmInstallAction(IEnumerable<IPluginDescription> plugins) {
+      foreach (var plugin in plugins) {
+        if (!string.IsNullOrEmpty(plugin.LicenseText)) {
+          var licenseConfirmationBox = new LicenseConfirmationBox(plugin);
+          if (licenseConfirmationBox.ShowDialog() != DialogResult.OK)
+            return false;
+        }
+      }
+      return true;
+    }
+
 
     #endregion
@@ -306,5 +319,5 @@
       toolStripProgressBar.Visible = true;
       DisableControls();
-      refreshServerPluginsBackgroundWorker.RunWorkerAsync(serverUrlTextBox.Text);
+      refreshServerPluginsBackgroundWorker.RunWorkerAsync();
     }
 
@@ -320,5 +333,4 @@
       //ClearPluginsList(remotePluginsListView);
       refreshButton.Enabled = true;
-      serverUrlTextBox.Enabled = true;
       toolStripProgressBar.Visible = false;
       Cursor = Cursors.Default;
@@ -327,5 +339,4 @@
     private void UpdateControlsConnected() {
       refreshButton.Enabled = true;
-      serverUrlTextBox.Enabled = true;
       toolStripProgressBar.Visible = false;
       Cursor = Cursors.Default;
@@ -345,4 +356,8 @@
       installButton.Enabled = remotePluginInstaller.CheckedPlugins.Count() > 0;
     }
+
+    private void editConnectionButton_Click(object sender, EventArgs e) {
+      (new ConnectionSetupView()).ShowInForm();
+    }
   }
 }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.Designer.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.Designer.cs	(revision 3006)
@@ -0,0 +1,98 @@
+﻿namespace HeuristicLab.PluginInfrastructure.Advanced {
+  partial class LicenseConfirmationBox {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.richTextBox = new System.Windows.Forms.RichTextBox();
+      this.acceptButton = new System.Windows.Forms.Button();
+      this.rejectButton = new System.Windows.Forms.Button();
+      this.licenseLabel = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // richTextBox
+      // 
+      this.richTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.richTextBox.Location = new System.Drawing.Point(12, 37);
+      this.richTextBox.Name = "richTextBox";
+      this.richTextBox.ReadOnly = true;
+      this.richTextBox.Size = new System.Drawing.Size(494, 351);
+      this.richTextBox.TabIndex = 0;
+      this.richTextBox.Text = "";
+      // 
+      // acceptButton
+      // 
+      this.acceptButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.acceptButton.Location = new System.Drawing.Point(298, 394);
+      this.acceptButton.Name = "acceptButton";
+      this.acceptButton.Size = new System.Drawing.Size(75, 23);
+      this.acceptButton.TabIndex = 1;
+      this.acceptButton.Text = "I Accept ";
+      this.acceptButton.UseVisualStyleBackColor = true;
+      this.acceptButton.Click += new System.EventHandler(this.acceptButton_Click);
+      // 
+      // rejectButton
+      // 
+      this.rejectButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.rejectButton.Location = new System.Drawing.Point(379, 394);
+      this.rejectButton.Name = "rejectButton";
+      this.rejectButton.Size = new System.Drawing.Size(127, 23);
+      this.rejectButton.TabIndex = 2;
+      this.rejectButton.Text = "Cancel Installation";
+      this.rejectButton.UseVisualStyleBackColor = true;
+      this.rejectButton.Click += new System.EventHandler(this.rejectButton_Click);
+      // 
+      // licenseLabel
+      // 
+      this.licenseLabel.AutoSize = true;
+      this.licenseLabel.Location = new System.Drawing.Point(13, 13);
+      this.licenseLabel.Name = "licenseLabel";
+      this.licenseLabel.Size = new System.Drawing.Size(177, 13);
+      this.licenseLabel.TabIndex = 3;
+      this.licenseLabel.Text = "Please confirm license agreement of";
+      // 
+      // LicenseConfirmationBox
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(518, 429);
+      this.Controls.Add(this.licenseLabel);
+      this.Controls.Add(this.rejectButton);
+      this.Controls.Add(this.acceptButton);
+      this.Controls.Add(this.richTextBox);
+      this.Name = "LicenseConfirmationBox";
+      this.Text = "License Agreement";
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.RichTextBox richTextBox;
+    private System.Windows.Forms.Button acceptButton;
+    private System.Windows.Forms.Button rejectButton;
+    private System.Windows.Forms.Label licenseLabel;
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseConfirmationBox.cs	(revision 3006)
@@ -0,0 +1,33 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  public partial class LicenseConfirmationBox : Form {
+    public LicenseConfirmationBox() {
+      InitializeComponent();
+    }
+
+    public LicenseConfirmationBox(IPluginDescription plugin) {
+      InitializeComponent();
+      richTextBox.Text = plugin.LicenseText;
+      licenseLabel.Text = plugin.ToString() + " " + licenseLabel.Text;
+      this.DialogResult = DialogResult.Cancel;
+    }
+
+    private void acceptButton_Click(object sender, EventArgs e) {
+      DialogResult = DialogResult.OK;
+      this.Close();
+    }
+
+    private void rejectButton_Click(object sender, EventArgs e) {
+      DialogResult = DialogResult.Cancel;
+      this.Close();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.Designer.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.Designer.cs	(revision 3006)
@@ -0,0 +1,57 @@
+﻿namespace HeuristicLab.PluginInfrastructure.Advanced {
+  partial class LicenseView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.richTextBox = new System.Windows.Forms.RichTextBox();
+      this.SuspendLayout();
+      // 
+      // richTextBox
+      // 
+      this.richTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.richTextBox.Location = new System.Drawing.Point(0, 0);
+      this.richTextBox.Name = "richTextBox";
+      this.richTextBox.ReadOnly = true;
+      this.richTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.Vertical;
+      this.richTextBox.Size = new System.Drawing.Size(426, 481);
+      this.richTextBox.TabIndex = 1;
+      this.richTextBox.Text = "";
+      // 
+      // LicenseView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.richTextBox);
+      this.Name = "LicenseView";
+      this.Size = new System.Drawing.Size(426, 481);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.RichTextBox richTextBox;
+
+
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LicenseView.cs	(revision 3006)
@@ -0,0 +1,25 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal partial class LicenseView : InstallationManagerControl {
+
+    public LicenseView() {
+      InitializeComponent();
+      Name = "License";
+    }
+
+    public LicenseView(IPluginDescription plugin) {
+      InitializeComponent();
+      Name = "License of: " + plugin;
+      richTextBox.Text = plugin.LicenseText;
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs	(revision 3006)
@@ -57,4 +57,5 @@
       this.localPluginsListView.UseCompatibleStateImageBehavior = false;
       this.localPluginsListView.View = System.Windows.Forms.View.Details;
+      this.localPluginsListView.ItemActivate += new System.EventHandler(this.localPluginsListView_ItemActivate);
       this.localPluginsListView.ItemChecked += new System.Windows.Forms.ItemCheckedEventHandler(this.pluginsListView_ItemChecked);
       // 
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.cs	(revision 3006)
@@ -92,4 +92,12 @@
       if (ItemChecked != null) ItemChecked(this, e);
     }
+
+    private void localPluginsListView_ItemActivate(object sender, EventArgs e) {
+      if (localPluginsListView.SelectedItems.Count > 0) {
+        var plugin = (PluginDescription)localPluginsListView.SelectedItems[0].Tag;
+        PluginView pluginView = new PluginView(plugin);
+        pluginView.ShowInForm();
+      }
+    }
   }
 }
